package com.tzld.piaoquan.recommend.server;

// import com.tzld.piaoquan.recommend.feature.client.FeatureClient;
import com.tzld.piaoquan.recommend.feature.client.FeatureClient;
import com.tzld.piaoquan.recommend.server.dataloader.ItemFeatureToRedisLoader;
import com.tzld.piaoquan.recommend.server.dataloader.OfflineAdOutSamplesLoader;
import com.tzld.piaoquan.recommend.server.dataloader.UserFeatureToRedisLoader;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.EnableAspectJAutoProxy;


/**
 * https://github.com/grpc-swagger/grpc-swagger/blob/master/README_CN.md
 */
@SpringBootApplication
@ComponentScan({
        "com.tzld.piaoquan.recommend.server.service",
        "com.tzld.piaoquan.recommend.server.grpcservice",
        "com.tzld.piaoquan.recommend.server.remote",
        "com.tzld.piaoquan.recommend.server.config",
        "com.tzld.piaoquan.recommend.server.web"
})
@EnableEurekaClient
@EnableAspectJAutoProxy
public class Application {
    public static void main(String[] args) {
        SpringApplication.run(Application.class, args);

        // OfflineAdOutSamplesLoader.mutiplyParser("alg_recsys_video_info", "20231207", "20231207");

//        UserFeatureToRedisLoader userFeatureToRedisLoader = new UserFeatureToRedisLoader();
//        userFeatureToRedisLoader.loadFeatureToRedis("alg_recsys_user_info", "20231207");


    }


    @Bean
    public FeatureClient featureClient() {
        return new FeatureClient();
    }


}

