package com.tzld.piaoquan.recommend.server.common.base;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.tzld.piaoquan.recommend.server.util.JSONUtils;
import lombok.Data;
import lombok.Getter;
import lombok.NoArgsConstructor;

@Getter
@NoArgsConstructor
public class ItemFeature {
    private String videoId;

    private String upId;

    private String tags;

    /**
     * 有多个标题，暂时不会用到所以先不处理
     * @since 2023-12-05
     */
    private String title;

    private String titleLength;

    private String playLength;

    private String totalTime;

    private String daysSinceUpload;


    // 当天统计量信息
    private UserActionFeature day1_cnt_features;
    // 3天内统计量
    private UserActionFeature day3_cnt_features;
    // 7天内统计量
    private UserActionFeature day7_cnt_features;
    // 3个月统计量
    private UserActionFeature month3_cnt_features;


    public void setVideoId(String key){
        if(key == null){
            this.videoId = "0";
        } else {
            this.videoId = key;
        }
    }

    public void setUpId(String key){
        if(key == null){
            this.upId = "0";
        } else {
            this.upId = key;
        }
    }

    public void setTags(String key){
        if(key == null){
            this.tags = "0";
        } else {
            this.tags = key;
        }
    }

    public void setTitle(String key){
        if(key == null){
            this.title = "0";
        } else {
            this.title = key;
        }
    }


    public void setDay1_cnt_features(UserActionFeature feature){
        this.day1_cnt_features = feature;
    }


    public void setDay3_cnt_features(UserActionFeature feature){
        this.day3_cnt_features = feature;

    }

    public void setDay7_cnt_features(UserActionFeature feature){
        this.day7_cnt_features = feature;

    }

    public void setMonth3_cnt_features(UserActionFeature feature){
        this.month3_cnt_features= feature;

    }

    public void setTitleLength(String key) {
        if(key == null){
            this.titleLength = "0";
        } else {
            this.titleLength = key;
        }
    }


    public void setDaysSinceUpload(String key) {
        if(key == null){
            this.daysSinceUpload = "0";
        } else {
            this.daysSinceUpload = key;
        }
    }

    public void setPlayLength(String key) {
        if(key == null){
            this.playLength = "0";
        } else {
            this.playLength = key;
        }
    }

    public void setTotalTime(String key) {
        if(key == null){
            this.totalTime = "0";
        } else {
            this.totalTime = key;
        }
    }

    public String getKey() {
        return this.videoId;
    }

    public String getValue(){
        Gson gson = new GsonBuilder().serializeSpecialFloatingPointValues().create();
        return gson.toJson(this);
    }


}
