package com.tzld.piaoquan.recommend.server.common.base;

import com.tzld.piaoquan.recommend.server.model.Video;
import lombok.Data;

import java.util.Map;


@Data
public class RankItem implements Comparable<RankItem> {
    public long videoId;
    private double score; // 记录最终的score
    private Video video;

    // 记录Item侧用到的特征
    private ItemFeature itemFeature;

    public RankItem(Video video) {
        this.videoId = video.getVideoId();
        this.score = 0.0;
        this.video = video;
    }

    private Map<String, Double> rankerScore;
    private Map<String, Integer> rankerIndex;


    @Override
    public int compareTo(RankItem o) {
        if (o == null) {
            return -1;
        }
        if (score > o.score) {
            return -1;
        } else if (score < o.score) {
            return 1;
        } else {
            return 0;
        }
    }


}
