package com.tzld.piaoquan.recommend.server.common.base;

import lombok.Data;

import java.util.Map;
import java.lang.Math;

@Data
public class UserActionFeature {
    private double exp_cnt;
    private double click_cnt;
    private double share_cnt;
    private double return_cnt;

    private double ctr;
    private double str;
    private double rov;
    private double ros;

    private double ceilLog(Double key) {
        return Math.ceil(Math.log(key));
    }

    private double bucketRatioFeature(Double key) {
        long bucket = Math.round(Math.log(key * 100));
        if( bucket > 100)
            bucket = 100;
        return (double) bucket;
    }


    public void setExp_cnt(Object key){
        if(key == null ) {
            this.exp_cnt = 0.0;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.exp_cnt = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setClick_cnt(Object key){
        if(key == null ){
            this.click_cnt = 0.0 ;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.click_cnt = ceilLog(Double.valueOf(formateKey));
        }
    }
    public void setShare_cnt(Object key){
        if(key == null ){
            this.share_cnt = 0.0 ;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.share_cnt = ceilLog(Double.valueOf(formateKey));
        }
    }
    public void setReturn_cnt(Object key){
        if(key == null ){
            this.return_cnt = 0.0 ;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.return_cnt = ceilLog(Double.valueOf(formateKey));
        }
    }

    public void setCtr(Object key){
        if(key == null ){
            this.ctr = 0.0 ;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.ctr = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }

    public void setStr(Object key){
        if(key == null ){
            this.str = 0.0 ;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.str = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }

    public void setRov(Object key){
        if(key == null ){
            this.rov = 0.0 ;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.rov = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }

    public void setRos(Object key){
        if(key == null ){
            this.ros = 0.0 ;
        } else {
            String formateKey = key.toString().replace("\\N", "-1");
            this.ros = bucketRatioFeature(Double.valueOf(formateKey));
        }
    }










}
