package com.tzld.piaoquan.recommend.server.common.enums;

public enum VlogFeatureGroup {

    // video
    APPTYP,
    VIDEOID,
    MID,
    UID,
    MACHINEINFO_BRAND,
    MACHINEINFO_MODEL,
    MACHINEINFO_PLATFORM,
    MACHINEINFO_SDKVERSION,
    MACHINEINFO_SYSTEM,
    MACHINEINFO_WECHATVERSION,
    UP_ID,
    TITLE_LEN,
    PLAY_LEN,
    TOTAL_TIME,
    DAYS_SINCE_UPLOAD,
    DAY,
    WEEK,
    HOUR,
    REGION,
    CITY,

    USER_1DAY_EXP,
    USER_1DAY_CLICK,
    USER_1DAY_SHARE,
    USER_1DAY_RETURN,
    USER_1DAY_CTR,
    USER_1DAY_STR,
    USER_1DAY_ROV,
    USER_1DAY_ROS,

    USER_3DAY_EXP,
    USER_3DAY_CLICK,
    USER_3DAY_SHARE,
    USER_3DAY_RETURN,
    USER_3DAY_CTR,
    USER_3DAY_STR,
    USER_3DAY_ROV,
    USER_3DAY_ROS,

    USER_7DAY_EXP,
    USER_7DAY_CLICK,
    USER_7DAY_SHARE,
    USER_7DAY_RETURN,
    USER_7DAY_CTR,
    USER_7DAY_STR,
    USER_7DAY_ROV,
    USER_7DAY_ROS,

    USER_3MONTH_EXP,
    USER_3MONTH_CLICK,
    USER_3MONTH_SHARE,
    USER_3MONTH_RETURN,
    USER_3MONTH_CTR,
    USER_3MONTH_STR,
    USER_3MONTH_ROV,
    USER_3MONTH_ROS,


    ITEM_1DAY_EXP,
    ITEM_1DAY_CLICK,
    ITEM_1DAY_SHARE,
    ITEM_1DAY_RETURN,
    ITEM_1DAY_CTR,
    ITEM_1DAY_STR,
    ITEM_1DAY_ROV,
    ITEM_1DAY_ROS,

    ITEM_3DAY_EXP,
    ITEM_3DAY_CLICK,
    ITEM_3DAY_SHARE,
    ITEM_3DAY_RETURN,
    ITEM_3DAY_CTR,
    ITEM_3DAY_STR,
    ITEM_3DAY_ROV,
    ITEM_3DAY_ROS,

    ITEM_7DAY_EXP,
    ITEM_7DAY_CLICK,
    ITEM_7DAY_SHARE,
    ITEM_7DAY_RETURN,
    ITEM_7DAY_CTR,
    ITEM_7DAY_STR,
    ITEM_7DAY_ROV,
    ITEM_7DAY_ROS,

    ITEM_3MONTH_EXP,
    ITEM_3MONTH_CLICK,
    ITEM_3MONTH_SHARE,
    ITEM_3MONTH_RETURN,
    ITEM_3MONTH_CTR,
    ITEM_3MONTH_STR,
    ITEM_3MONTH_ROV,
    ITEM_3MONTH_ROS,


    USER_CYCLE_BUCKET_7DAY,
    USER_CYCLE_BUCKET_30DAY,
    USER_SHARE_BUCKET_30DAY,
    ;


    private final byte[] idBytes;
    private final byte[] nameBytes;

    VlogFeatureGroup() {
        this.nameBytes = name().toLowerCase().getBytes();
        this.idBytes = String.valueOf(ordinal()).getBytes();
    }

    public final int getId() {
        return ordinal();
    }

    public final String getGroupName() {
        return name().toLowerCase();
    }

    public final byte[] getGroupNameBytes() {
        return getGroupName().getBytes();
    }

    public final byte[] getIdBytes() {
        return idBytes;
    }

}
