package com.tzld.piaoquan.recommend.server.service.score.feature;

import com.typesafe.config.Config;
import com.typesafe.config.ConfigFactory;
import com.typesafe.config.ConfigObject;
import com.typesafe.config.ConfigValue;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

public class FeatureUsage implements Serializable {
    private final Logger LOGGER = LoggerFactory.getLogger(FeatureUsage.class);
    private Set<String> hash;

    public FeatureUsage() {
        hash = new HashSet<String>();
    }

    public FeatureUsage(String confName) {
        // note that these fields are NOT lazy, because if we're going to get any exceptions, we want to get them on startup.
        Config config = ConfigFactory.load(confName);
        config.checkValid(config, "features");
        ConfigObject conf = config.getConfig("features").root();
        LOGGER.info("create_feature_usage: " + confName);
        hash = new HashSet<String>();
        for (ConfigObject.Entry<String, ConfigValue> it : conf.entrySet()) {
            String key = it.getKey();
            Config cf = ((ConfigObject) it.getValue()).toConfig();
            LOGGER.info("key: " + key + ", value: " + cf.toString());
            boolean disable = cf.getBoolean("disable");
            if (disable) {
                hash.add(key);
            }
        }
    }

    public boolean disable(String fea) {
        return hash.contains(fea);
    }
}
